---
title: Xamarin.Android warning XA0121
description: XA0121 warning code
ms.date: 09/19/2019
---
# Xamarin.Android warning XA0121

## Issue

The behavior implemented in the
`<GetAdditionalResourcesFromAssemblies/>` MSBuild task is now
deprecated.

This MSBuild task is a precursor to [Xamarin.Build.Download][xbd] that
enables downloading of Android packages from the internet.

Libraries using any of the following custom assembly-level attributes
will encounter this warning:

* `IncludeAndroidResourcesFromAttribute`
* `NativeLibraryReferenceAttribute`
* `JavaLibraryReferenceAttribute`

## Solution

The [Xamarin Support Libraries][supportlibs], can be simply updated to
a newer version on NuGet.

Library authors will need to remove usage of these deprecated
attributes. Their functionality will be removed in a future version of
Xamarin.Android.

[xbd]: https://www.nuget.org/packages/Xamarin.Build.Download
[supportlibs]: https://github.com/xamarin/AndroidSupportComponents
