---
title: Xamarin.Android error XA1002
description: XA1002 error code
ms.date: 08/02/2018
---
# Xamarin.Android error XA1002

## Example messages

```
We found a matching key 'Namespace.CustomViewFoo' for 'NameSpace.CustomViewFoo'. But the casing was incorrect. Please correct the casing
```

## Issue

This error will be emitted when we are unable to find a matching custom view in the
ResourceCaseMap string.

As part of the build process, `Namespace.CustomViewFoo` items in layout files are
replaced with `{MD5Hash}.CustomViewFoo`. We attempt to replace a couple of variants
of the `Namespace.CustomViewFoo`. One is the original casing found in the C# source
files. The other is all lowercase. If we cannot find a match, we will do a case
insensitive lookup to see if there are items which do match. If we find one, this
error will be raised.